﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Syncfusion.Blazor;
using UrlAdaptor.Data;
using Syncfusion.Blazor.Data;
using System.Dynamic;
using System.Runtime.CompilerServices;

namespace UrlAdaptor.Controller
{

    [ApiController]
    public class ValuesController : ControllerBase
    {
        public ValuesController()
        {
            BindDataSource();
        }
        public static List<TreeData.BusinessObject> TreeGridData = new List<TreeData.BusinessObject>();

        [HttpPost]
        [Route("api/[controller]")]
        public object Post([FromBody] DataManagerRequest dm)
        {
            IEnumerable DataSource = TreeData.GetSelfDataSource();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = DataOperations.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = DataOperations.PerformSorting(DataSource, dm.Sorted);
            }

            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = DataOperations.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<TreeData.BusinessObject>().Count();
            if (dm.Skip != 0)
            {
                DataSource = DataOperations.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = DataOperations.PerformTake(DataSource, dm.Take);
            }
          //  return new { result = DataSource, count = count };
            return dm.RequiresCounts ? (new { result = DataSource, count = count }) : (DataSource);

        }
        //IEnumerable DataSource = order.ToList();

        //[HttpPost]
        //[Route("api/Default/Batch")]
        //public object Batch([FromBody] CRUDModel<TreeData.BusinessObject> changed)
        //{
        //    if (changed.Added.Count != 0 && TreeGridData.Count < 9)
        //    {
        //        TreeGridData.Insert(changed.DropIndex, changed.Added[0]);
        //    }
        //    if (changed.Deleted.Count != 0)
        //    {
        //        foreach (var item in TreeGridData)
        //        {
        //            if (item.TaskId == changed.Deleted[0].TaskId)
        //            {
        //                TreeGridData.Remove(item);
        //                break;

        //            }
        //        }
        //    }
        //    return new { result = TreeGridData };
        //}
        private void BindDataSource()
        {
            if (TreeGridData.Count == 0)
            {
                TreeGridData = TreeData.GetSelfDataSource().ToList();
            }
        }

    }

}
