using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.HttpsPolicy;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;
using Syncfusion.Blazor;
using UrlAdaptor.Data;
using Microsoft.AspNetCore.Mvc.NewtonsoftJson;
using Newtonsoft.Json.Serialization;

namespace UrlAdaptor
{
    public class Startup
    {
        public Startup(IConfiguration configuration)
        {
            Configuration = configuration;
        }

        public IConfiguration Configuration { get; }

         // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddRazorPages();
            services.AddServerSideBlazor();
            services.AddScoped<HttpClient>(factory => new HttpClient(new HttpClientHandler()
            {
                ServerCertificateCustomValidationCallback = (HttpRequestMessage m, System.Security.Cryptography.X509Certificates.X509Certificate2 f, System.Security.Cryptography.X509Certificates.X509Chain x, System.Net.Security.SslPolicyErrors d) => true
            }));

            services.AddMvc().AddNewtonsoftJson(options => {
                options.SerializerSettings.ContractResolver = new DefaultContractResolver();
            });
            //services.AddSingleton<WeatherForecastService>();
            services.AddSyncfusionBlazor(options => { });
            //Syncfusion.Licensing.SyncfusionLicenseProvider.RegisterLicense("Mgo+DSMBaFt/QHRqVVhjVFpGaV1AQmFJfFBmQWlYdlRzckU3HVdTRHRcQlxhTX5Xc0VnW3dZcnw=;Mgo+DSMBPh8sVXJ0S0J+XE9HflRAQmFLYVF2R2BJe1RxfV9FZkwgOX1dQl9gSX9RckVnXH9acnxcRGg=;ORg4AjUWIQA/Gnt2VVhkQlFadVdJX3xLfEx0RWFab1p6dVxMY1pBNQtUQF1hSn5SdEFjXXpedHZcR2BU;OTk0NDQ3QDMyMzAyZTM0MmUzMEs1MjNzeDJaT0JhaEU3ajVZdmpRdkNXYnNOaThvTmtuWFBKQjJHTkxKSEU9;OTk0NDQ4QDMyMzAyZTM0MmUzMFh6S0d2bzkvVW9pdW9IWDZ0NGVXb3Y0VkFUcSs4SHFOcVJReDg1blJvbHM9;NRAiBiAaIQQuGjN/V0Z+WE9EaFxKVmFWfFFpR2NbfE50flRPal9XVAciSV9jS31Td0dnWXtbcHBXT2daWQ==;OTk0NDUwQDMyMzAyZTM0MmUzMEp4dk5LZlpibGgyOW83NDBYTkFCZkY5MC83MXZOVnlyOElCNExNaGhzclU9;OTk0NDUxQDMyMzAyZTM0MmUzMFFsY1M3Njk3dGRGUExEMkRWekNlTy9pNDRXVGs2UjdsL01WWCtGaHNmVGM9;Mgo+DSMBMAY9C3t2VVhkQlFadVdJX3xLfEx0RWFab1p6dVxMY1pBNQtUQF1hSn5SdEFjXXpedHdVQWJU;OTk0NDUzQDMyMzAyZTM0MmUzMEZ1VEJXZ0EwUW9Bc0pkNklCL3lKVEZtTkJuaEFyaUl3NVhMVENUTzNMb2M9;OTk0NDU0QDMyMzAyZTM0MmUzMEtMWjJWdDdBSEdpRzNKbmtHdXlVWDRVb3NrV3lFZGxtM2JrZEpkZGtjSXc9;OTk0NDU1QDMyMzAyZTM0MmUzMEp4dk5LZlpibGgyOW83NDBYTkFCZkY5MC83MXZOVnlyOElCNExNaGhzclU9");
          // Syncfusion.Licensing.SyncfusionLicenseProvider.RegisterLicense("Mgo+DSMBaFt+QHFqVkFrWE5GcUBAXWFKblF8QGJTfldgBShNYlxTR3ZbQlljS3pQdkZgWHpe;Mgo+DSMBPh8sVXJ1S0d+X1ZPckBAWnxLflF1VWFTel96dVxWESFaRnZdQV1nSXpTdEFgWXxdcnNV;ORg4AjUWIQA/Gnt2VFhhQlJDfVtdX2RWfFN0RnNbdVtxflRPcC0sT3RfQF5jTX5XdkdnWn9dc3dcRg==;MTYwNTAwM0AzMjMxMmUzMTJlMzMzN004V1FKc0ozM3FQZzcwa3MrUEV6bGhSTjRvSjZseWU5eCswaFNjRWlnYm89;MTYwNTAwNEAzMjMxMmUzMTJlMzMzN0JsUGRFeEZwdjNwYmtLNDR1cDFwN2k3K0pVa1R6S3hzMzJ5VlBrY1JkR1E9;NRAiBiAaIQQuGjN/V0d+XU9HcVRGQmFOYVF2R2BJfVR1dV9HaUwgOX1dQl9gSXpTckVhXXxec3ddQWA=;MTYwNTAwNkAzMjMxMmUzMTJlMzMzN29DQmNGcHRlck1lMWt6SEJCWFdJRzFKMzkxUEoxZk5uM1NaTDEyck1vN0E9;MTYwNTAwN0AzMjMxMmUzMTJlMzMzN2ZNTXZKSVJYT3ZqZjRkVUZSWWduaGx2ZUpYb1EyRUh5YjBHeE10NGVQU009;Mgo+DSMBMAY9C3t2VFhhQlJDfVtdX2RWfFN0RnNbdVtxflRPcC0sT3RfQF5jTX5XdkdnWn9ddHdTRg==;MTYwNTAwOUAzMjMxMmUzMTJlMzMzN0RBTnoxMVoxQW9SZHVabkZMeFRUQ0hnS09QS05Ea1NmbUF0czRUaWhqM0E9;MTYwNTAxMEAzMjMxMmUzMTJlMzMzN1JMbm1pdm5ndk00OFFkRS9abGtvWldTSS9maHB3am9UdWRFVUxmTlpRNWs9;MTYwNTAxMUAzMjMxMmUzMTJlMzMzN29DQmNGcHRlck1lMWt6SEJCWFdJRzFKMzkxUEoxZk5uM1NaTDEyck1vN0E9"); 
                }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IWebHostEnvironment env)
        {
            if (env.IsDevelopment())
            {
                app.UseDeveloperExceptionPage();
            }
            else
            {
                app.UseExceptionHandler("/Error");
                // The default HSTS value is 30 days. You may want to change this for production scenarios, see https://aka.ms/aspnetcore-hsts.
                app.UseHsts();
            }

            app.UseHttpsRedirection();
            app.UseStaticFiles();

            app.UseRouting();

            app.UseEndpoints(endpoints =>
            {
                endpoints.MapDefaultControllerRoute();
                endpoints.MapBlazorHub();
                endpoints.MapFallbackToPage("/_Host");
            });
        }
    }
}
